<?php
/*********************************************************************************************************************
* download.php Version 3.1 - [08/04/2024]
* permet l'affichage d'items de téléchargement avec un comptage dynamique dans une seule page de type "accordéon" 
* Le script "compteur" est issu de https://sdz.tdct.org/sdz/compteur-de-telechargements.html
* Le script "pages accordéon" est issu de https://tympanus.net/codrops/2012/02/21/accordion-with-css3/ par Mary-Lou
* Pour cette version, les réglages d'effectuent uniquement par l'intermédiaire du module Download 3.0 intégré dans adHoc
* Adaptations et Intégration dans adHoc Jean-Denis https://adhoc.71site.fr (v 1.0 janv.2021) (v 2.0 janv.2024) (v 3.0 fév.2024) (v 3.1 avr.2024)
* D'après modules réalisés par Penanders https://www.cmsadhoc.net/
* Il est nécessaire d'avoir créé, dans l'admin, chacunes des fiches de liens,...
* ...dans une ou plusieurs catégories dédiées, dans une ou plusieurs "boîtes menu" privées ou publiques
* Licence : GNU-GPL V3
**********************************************************************************************************************/

// Construction de la page
require_once("include/config.inc");

// Variables à ne modifier que si c'est vraiment nécessaire...
$folder_stat = 'data/download/' ; // C'EST LE PLUS PRATIQUE : répertoire dans lequel seront stockées les statistiques 
										// !! ATTENTION : si modifié, doit être strictement identique plus bas dans la fonction NumberOfHit
$folder_archive = 'files/' ; // C'EST LE PLUS PRATIQUE : répertoire des téléchargements

// Importation des variables
	$cfg_download = ReadCSVPairs(PATH_DAT."download/config".DBEXT); // lecture fichier de configuration du module config.dtb

	$numcat0 = $cfg_download['numcat0']; // numéro de la catégorie n°1 utilisée pour les items
	$numcat1 = $cfg_download['numcat1']; // numéro de la catégorie n°2 utilisée pour les items
	$numcat2 = $cfg_download['numcat2']; // numéro de la catégorie n°3 utilisée pour les items
	$numcat3 = $cfg_download['numcat3']; // numéro de la catégorie n°4 utilisée pour les items
	$numcat4 = $cfg_download['numcat4']; // numéro de la catégorie n°5 utilisée pour les items
	$numcat5 = $cfg_download['numcat5']; // numéro de la catégorie n°6 utilisée pour les items
	$numcat6 = $cfg_download['numcat6']; // numéro de la catégorie n°7 utilisée pour les items
	$numcat7 = $cfg_download['numcat7']; // numéro de la catégorie n°8 utilisée pour les items
	$numcat8 = $cfg_download['numcat8']; // numéro de la catégorie n°9 utilisée pour les items
	$numcat9 = $cfg_download['numcat9']; // numéro de la catégorie n°10 utilisée pour les items

	$nomcourt0 = $cfg_download['nomcategoriecourt0']; // nom court catégorie n°1 utilisée pour les items
	$nomcourt1 = $cfg_download['nomcategoriecourt1']; // nom court catégorie n°2 utilisée pour les items
	$nomcourt2 = $cfg_download['nomcategoriecourt2']; // nom court catégorie n°3 utilisée pour les items
	$nomcourt3 = $cfg_download['nomcategoriecourt3']; // nom court catégorie n°4 utilisée pour les items
	$nomcourt4 = $cfg_download['nomcategoriecourt4']; // nom court catégorie n°5 utilisée pour les items
	$nomcourt5 = $cfg_download['nomcategoriecourt5']; // nom court catégorie n°6 utilisée pour les items
	$nomcourt6 = $cfg_download['nomcategoriecourt6']; // nom court catégorie n°7 utilisée pour les items
	$nomcourt7 = $cfg_download['nomcategoriecourt7']; // nom court catégorie n°8 utilisée pour les items
	$nomcourt8 = $cfg_download['nomcategoriecourt8']; // nom court catégorie n°9 utilisée pour les items
	$nomcourt9 = $cfg_download['nomcategoriecourt9']; // nom court catégorie n°10 utilisée pour les items

	// liste des numéros (Id) des catégories dans l'ordre où vous souhaitez qu'elles s'affichent
	$numcategorie = array($numcat0, $numcat1, $numcat2, $numcat3, $numcat4, $numcat5, $numcat6, $numcat7, $numcat8, $numcat9);
	// liste des noms courts des catégories dans le même ordre (permet de passer une variable dans l'URL de download.php pour ouvrir un soufflet)
	$nomcategoriecourt = array($nomcourt0, $nomcourt1, $nomcourt2, $nomcourt3, $nomcourt4, $nomcourt5, $nomcourt6, $nomcourt7, $nomccourt8, $nomcourt9);
	 // type d'accordéon souhaité
	$typeaccordeon = $cfg_download['typeaccordeon'];

	// tous les volets de l'accordéon sont ouverts par défaut si oui et type checkbox // sinon fermés
	if ($cfg_download['tousouverts'] == 'oui' && $cfg_download['typeaccordeon'] == 'checkbox')
		{$tousouverts = 'checked="checked"';} else {$tousouverts = '';}

	// éventuellement un nom court de catégorie à ouvrir par défaut
	$categorieouverte = '';
	for ($i=0; $i < count($numcategorie) ; $i++) {
		if ($cfg_download['categorieouverte'] == $numcategorie[$i])
			{$categorieouverte = $nomcategoriecourt[$i];} 
	}

	if ($cfg_download['connex'] == 'non') {$connex = 0;} else {$connex = 1;} // 0 : accessible au visiteur // ou 1 : accessible après connexion

	$affdate = $cfg_download['affdate']; // affichage date
	if ($cfg_download['coum'] == 'crea') {$coum = 3;} else {$coum = 4;} // date création : 3 ou date dernière modification : 4
	$SouC = $cfg_download['SouC']; // 'S' : simple (sans heure) // 'C' : complète (date et heure)
	$cible = $cfg_download['cible']; // cible du lien


	// définition des variables de langue
	$idlg = USER_LANG;
	$meta['title'] = $cfg_download['meta_tit_'.$idlg]; // titre de la page (onglet) 
	$meta['description'] = $cfg_download['meta_des_'.$idlg]; // description (code source)
	$topmess = $cfg_download['topmessage_'.$idlg]; // nom de la page
	$prive = $cfg_download['info_prive_'.$idlg]; // avertissement si privé
	$message[3] = $cfg_download['messagecrea_'.$idlg]; // message création si date
	$message[4] = $cfg_download['messagemodif_'.$idlg]; // massage modification si date

	// définitions supplémentaires des variables de langue
	if (USER_LANG == 'it') { // it
	$telecharge = 'Telescritto ' ;
	$fois = ' volte' ;
	}
	elseif (USER_LANG == 'en') { // en
	$telecharge = 'Downloaded ' ;
	$fois = ' times' ;
	}
	else { // par défaut en fr
	$telecharge = 'Téléchargé ' ;
	$fois = ' fois' ;
	}

// Vérification du statut de connexion !!Attention ne fonctionnera qu'avec le CMS adHoc!!
if (empty($_COOKIE['adHocUser'])) { // pas de connexion donc ne voit que ce qui est public
	$statconnex = 0 ;
	}
else { // connexion donc voit aussi l'affichage privé
	$statconnex = 1 ;
	}

if ( isset( $_GET['cat'] ) ) // test existence du paramètre 'cat' passé dans l'URL
{ $categorie = $_GET['cat']; } // si oui récupération du paramètre 'cat'
else
{ $categorie = $categorieouverte; } // sinon catégorie ouverte de vos réglages


if ( isset( $_GET['file'] ) ) // si le visiteur veut télécharger un fichier
{
	$name = htmlentities($_GET['file'], ENT_QUOTES); // sécurisation de la variable

	if ( file_exists($folder_stat.$name.'.txt')) // si le fichier existe
	{
		$FileContent = fopen($folder_stat.$name.'.txt', 'r+' ); // ouverture du fichier statistique contenant le nombre de hits
		$hit = fgets( $FileContent ); // récupération de la valeur
		$hit = intval( $hit ); // on vérifie qu’il s’agisse bien d’un nombre
		$hit++; // ajout de 1 au nombre de hits
		fseek( $FileContent, 0 ); // réinitialisation du curseur
		fputs( $FileContent, $hit ); // écriture dans le fichier
		fclose( $FileContent ); // fermeture du fichier
		header( "Location: $folder_archive$name.zip" ); // redirection vers le téléchargement .zip
	}
}

// Fonctions
function NumberOfHit( $name ) // création de la fonction NumberOfHit
{
	$folder_stat = 'data/download/' ; // C'EST LE PLUS PRATIQUE : répertoire dans lequel seront stockées les statistiques
											// !! ATTENTION : si modifié, doit être strictement identique plus haut 
	$file = $folder_stat . $name . '.txt' ; // nom du fichier de statistiques contenant le nombre de hits

	if ( file_exists( $file ) ) // si le fichier existe
	{
		$FileContent = fopen( $file , 'r' ); // ouverture du fichier
		$hit = fgets( $FileContent ); // récupération de la valeur
		fclose( $FileContent ); // fermeture du fichier
		return $hit; // retour de la valeur de $hit
	}
	else // si le fichier n’existe pas
	{
		touch( $file ); // création du fichier
		$FileContent = fopen( $file  , 'r+' ); // ouverture du fichier
		fseek( $FileContent, 0 ); // réinitialisation du curseur
		fputs( $FileContent, 0 ); // écriture dans le fichier
		fclose( $FileContent ); // fermeture du fichier
	}
}

function statutboite($num) // fonction statutboite pour vérifier les droits d'affichage de cette boite
{
$nblignes = count(file('modules/pages/mod_lat_pages_'.$num.'.inc')); // nombre de lignes du fichier
$contenuboite = fopen( 'modules/pages/mod_lat_pages_'.$num.'.inc', 'r' ); // ouverture fichier et contenu
	for ($i=0; $i < $nblignes ; $i++) {
		$lignenouvelle = fgets($contenuboite);
		if (strncmp($lignenouvelle, '$pm_rights = ', 13) === 0) // vérification ligne droit
		{$droitboite = substr($lignenouvelle, 13, 1);} // récupération valeur droit
	}
fclose($contenuboite); // fermeture fichier
return $droitboite;
}

function affichagedateS($date) { // date simple
$pourdate = substr($date, 6, 2)."/".substr($date, 4, 2)."/".substr($date, 0, 4);
return $pourdate;
}

function affichagedateC($date) { // date complète (avec heure)
$pourdate = substr($date, 6, 2)."/".substr($date, 4, 2)."/".substr($date, 0, 4)." ".substr($date, 8, 2)."h".substr($date, 10, 2);
return $pourdate;
}

function nettoyagenom($nom) { // nettoyage éventuel du nom de catégorie ou de page
if ($nom[0] == '"' && substr($nom, -1) == '"') //test présence de guillemets au début ET à la fin
{$nom = substr($nom, 1, -1);} // ... les supprime le cas échéant
return $nom;
}

// construction de la page
include_once(PATH_INC."hpage.inc");
echo '
<!-- Début affichage "Module Download V3.1 // Service de Téléchargements" -->
';
htable($topmess, "100%");

// Affichage
if ($statconnex >= $connex) // vérification du statut avant affichage
{ // affichage en partie publique ou visiteur connecté

// Style
echo '
<link charset="utf-8" href="skin/css/CSS_textes_accordeon-download.css" rel="stylesheet" />'; //fichier de style


// Elaboration contenu de la liste de toutes les catégories
$comptenbcategories = count(file('data/pages/list_'.$idlg.'.dbt')); // nombre de catégories dans la liste
$contenucategories = fopen( 'data/pages/list_'.$idlg.'.dbt', 'r' ); // ouverture fichier et contenu de cette liste

for ($i=0; $i < $comptenbcategories ; $i++) {
	$lignenouvelle = fgets($contenucategories);
	$elem = explode(";", $lignenouvelle);
		for ($j=0; $j < 6;$j++) {
		$chaquecategorie [$i][$j] = $elem[$j]; // création variables [catégorie][élément]
		}
}
fclose($contenucategories); // fermeture fichier

echo '
<section class="ac-container"><!-- début ac-container -->'; // début container accordéon

for ($k=0; $k < count($numcategorie) ; $k++) { // boucle pour le nombre max de catégories à afficher
	for ($i=0; $i < $comptenbcategories ; $i++) { // boucle pour chaque catégorie
		if ( $numcategorie [$k] == $chaquecategorie [$i][0]) { // vérification si la catégorie fait partie de la liste à afficher
			if ($statconnex >= statutboite($chaquecategorie [$i][1])) { // vérification du statut de la boite contenant la catégorie
				if ($categorie == $nomcategoriecourt[$k] && $tousouverts == '') { // tests pour volet ouvert par défaut
					$ouvert = 'checked="checked"';}
					else {$ouvert = '';}
				if ($tousouverts == 'checked="checked"') {$ouvert = 'checked="checked"';} // tests pour volet ouvert par défaut

				// zone affichage nom catégorie
				echo '
				<div><!-- bloc ac-'.$numcategorie[$k].' -->
				<input '.$ouvert.' id="ac-'.$numcategorie[$k].'" name="accordion" type="'.$typeaccordeon.'" />
				<label for="ac-'.$numcategorie[$k].'">'.nettoyagenom($chaquecategorie [$i][3]).'</label>
				<article class="ac"><!-- début contenu volet accordéon -->';

				// Elaboration contenu de la catégorie en cours
				$comptenbritems = count(file('data/pages/pgidx_'.$numcategorie[$k].$idlg.'.dbt')); // nombre d'items dans la catégorie
				$contenucatencours = fopen( 'data/pages/pgidx_'.$numcategorie[$k].$idlg.'.dbt', 'r' ); // ouverture fichier et contenu de cette catégorie

				for ($x=0; $x < $comptenbritems ; $x++) {
					$lignenouvelle = fgets($contenucatencours);
					$elem = explode(";", $lignenouvelle);
						for ($y=0; $y < 6;$y++) {
						$chaqueitem [$x][$y] = $elem[$y]; // création variables [item][élément] pour tous les items
						}
					}
				fclose($contenucatencours); // fermeture fichier

				for ($z=0; $z < $comptenbritems ; $z++) {
					if ($chaqueitem [$z][2] == 'i') {continue;} // test de la page concernée (saute l'hypothèse si page inactive)
					include ('data/pages/page_'.$chaqueitem [$z][0].$idlg.'.inc'); // inclusion fichier page concernée
					$name = nettoyagenom($chaqueitem [$z][1]) ; // nom du fichier (et de l’archive) // nettoyage normalement inutile
					$comment = $ftxt; // commentaire pour ce téléchargement : récupération variable contenu page
					$result = NumberOfHit( $name ) ; // récupération du nombre de hits pour le nom concerné

// zone affichage contenu item - page concernée : lien, nom, éventuellement date, commentaire 
					if ($affdate == 'oui') { // test date
						if ($SouC == 'S')
						{$ladate = affichagedateS($chaqueitem [$z][$coum]);} // date simple
						else
						{$ladate = affichagedateC($chaqueitem [$z][$coum]);} // date complète
					$presencedate = '<span style="float:right;padding-right:40px;font-size:70%;"><i>'.$message[$coum].' '.$ladate.'</i></span>';}
					else { $presencedate = '';} // sans date

					echo '
					<h4><a href="?file='.$name.'"></a>'.$name.$presencedate.'</h4>
					<p>'.$telecharge.'<b>'.$result.'</b>'.$fois.'</p>
					<div class="comment">'.$comment.'</div>
					<div class="sep"></div><!-- ligne séparation -->';
				}
				
				echo '
				</article><!-- fin contenu volet accordéon -->
				</div><!-- fin bloc ac-'.$numcategorie[$k].' -->';
			} // fin test statut boite
		} // fin test catégorie
	} // fin boucle $i
} // fin boucle $k

echo '
</section><!-- fin ac-container -->'; // fin container accordéon

} else { // privé
	echo $prive;
	echo '<br>';
	echo '<hr><hr>';
	}

// Admin rapide et Référencement SVP ne pas supprimer
if(USER_LEVEL > 1) {
	echo '<span class="quick-links" style="background:transparent;"><a href="'.PATH.'admin/panel.php?pg=download"><img style="width:30px;height:30px;" src="'.PATH_LNK.'include/ico/settings.png" border="0" alt="admin" title="admin" /></a></span>';
}
echo '
<!-- "Module Download V3.1 // Service de Téléchargements" - Jean-Denis https://adhoc.71site.fr avril 2024 - Licence: GNU-GPL V3 -->
';

// fin contenu
btable();
include_once(PATH_INC."bpage.inc");
die();
?>

